class StruninnUICards_Elementor_Handler_Digital_Card extends elementorModules.frontend.handlers.Base {
  getDefaultElements() {
    const digitalCardElement = this.$element[0].querySelector('.struninnuicard-digital');

    /**
     * Create countdowns.
     * 
     * @since 1.0.0
     */
    const countdowns = digitalCardElement.querySelectorAll('.struninn-countdown');

    if (countdowns.length > 0) {
      for (const countdown of countdowns) {
        const countdownTargetDate = countdown.getAttribute('data-target-date');
        const countdownDate = new Date(countdownTargetDate).getTime();

        const countdownTextElement = countdown.querySelector('.countdown__text');

        if (countdownTextElement) {
          const updateCountdown = (countdownInterval) => {
            const now = new Date().getTime();
            const distance = countdownDate - now;

            const days = Math.floor(distance / (1000 * 60 * 60 * 24));
            const hours = Math.floor((distance % (1000 * 60 * 60 * 24)) / (1000 * 60 * 60));
            const minutes = Math.floor((distance % (1000 * 60 * 60)) / (1000 * 60));
            const seconds = Math.floor((distance % (1000 * 60)) / 1000);

            if (distance < 0) {
              clearInterval(countdownInterval);
              countdownTextElement.innerText = '0d : 00h : 00m: 00s';
            } else {
              countdownTextElement.innerText = `${days}d : ${hours}h : ${minutes}m : ${seconds}s`;
            }
            
          };

          const countdownInterval = setInterval(() => {
            updateCountdown(countdownInterval);
          }, 1000);

          updateCountdown();
        }
      }
    }

    return {
      digitalCard: digitalCardElement
    };
  }
}

window.addEventListener('elementor/frontend/init', () => {
  elementorFrontend.elementsHandler.attachHandler('struninnuicards_elementor_widget_digital_card_v1', StruninnUICards_Elementor_Handler_Digital_Card);
  elementorFrontend.elementsHandler.attachHandler('struninnuicards_elementor_widget_digital_card_v2', StruninnUICards_Elementor_Handler_Digital_Card);
  elementorFrontend.elementsHandler.attachHandler('struninnuicards_elementor_widget_digital_card_v3', StruninnUICards_Elementor_Handler_Digital_Card);
  elementorFrontend.elementsHandler.attachHandler('struninnuicards_elementor_widget_digital_card_v4', StruninnUICards_Elementor_Handler_Digital_Card);
});